<?php

namespace FiloBlu\GuestWishlist\Controller\Plugin;

class Share {

    protected $customerSession;
    protected $_helper;
    protected $resultPageFactory;
    protected $response;

    public function __construct(
    \Magento\Customer\Model\Session $customerSession, \FiloBlu\GuestWishlist\Helper\Data $helper, \Magento\Framework\View\Result\PageFactory $resultPageFactory, \Magento\Framework\App\Response\Http $response
    ) {
        $this->_helper = $helper;
        $this->customerSession = $customerSession;
        $this->resultPageFactory = $resultPageFactory;
        $this->response = $response;
    }

    public function afterExecute($object, $resultPage) {

        # Add 1column layout and remove sidebar for guest wishlist
        if ((!$this->customerSession->isLoggedIn() && $this->_helper->getConfig("general/enabled"))) {
            # Clear redirect
            $this->response->clearHeader("Location");
            $this->response->setHttpResponseCode(200);
            $resultPage = $this->resultPageFactory->create();
            $resultPage->getLayout()->
                    getUpdate()->
                    addHandle('wishlist_index_guest');
        }

        return $resultPage;
    }

}
